// ==UserScript==
// @name Feldspatatrac - Vue 2D MH
// @include http://games.mountyhall.com/mountyhall/MH_Play/Play_vue.php
// @include http://serv01.mountyhall.com/mountyhall/MH_Play/Play_vue.php
// @description Vue 2D ingame version 3.0.0.0 du 19 septembre 2009 par Feldspath
// @injectframes 1
// ==/UserScript==

//////////////////////
//Gnration de la map
//Slection des niveaux
function niveaux() {
	sel.innerHTML = "";
	nvspan = enligne("etik_niv");
	nvspan.innerHTML = "Niveau";
	sel.appendChild(nvspan);

	nvdiv = document.createElement("div");
	nvdiv.innerHTML = "Tous";
	nvdiv.className = "niv";
	nvdiv.style.left = "40px";
	addEvent(nvdiv, "click", tous, true);
	sel.appendChild(nvdiv);

	nvdiv = document.createElement("div");
	nvdiv.innerHTML = "aucun";
	nvdiv.className = "niv_out";
	nvdiv.style.left = "78px";
	nvdiv.style.width = "45px";
	addEvent(nvdiv, "click", aucun, true);
	sel.appendChild(nvdiv);

	decal_g = 126;
	vu = new Array();
	for (var j=nmin;j<=nmax;j++) {
		vu["S"+j] = true;
		strate = enligne("NS"+j);
		strate.appendChild(enligne("NS_moqp"+j));
		strate.lastChild.className = "i_moqp";
		strate.appendChild(enligne("NS_ooqp"+j));
		strate.lastChild.className = "i_ooqp";
		ancre.appendChild(strate);

		nvdiv = bloc("S"+j);
		nvdiv.className = "niv";
		nvdiv.style.left = decal_g+"px";
		nvdiv.innerHTML = j;
		addEvent(nvdiv, "click", etagc, true);
		addEvent(nvdiv, "mouseover", etag, true);
		addEvent(nvdiv, "mouseout", etago, true);
		sel.appendChild(nvdiv);
		decal_g += 38;
	}
	(document.getElementById("S"+n1)).style.backgroundImage="url("+chemin+"tab.png)";
}
//Affichage des images & texte
function c_case(v,h) {
	imag=document.createElement("img");
	imag.src=chemin+"case.png";
	imag.className = "case";
	imag.style.top = v+"px"; imag.style.left = h+"px";
	imag.alt="";
	ancre.appendChild(imag);
}
function p_txt(v,h,texte) {
	dive=document.createElement("span");
	dive.appendChild(document.createTextNode(texte));
	dive.style.position = "absolute"; dive.style.top = v+"px"; dive.style.left = h+"px";
	ancre.appendChild(dive);
}
//grille
function grille() {
	//quadrillage
	if(ie) {
		ec = [decal_v-18, parseInt(dh+.5*larg-6), parseInt(dv+.5*larg-7), decal_h-25, dv+h1*larg+1*larg+3, parseInt(dh+.5*larg-6), parseInt(dv+.5*larg-7), dh+h1*larg+1*larg+3];
		for (var j=-h1;j<=h1;j++) {//grille
			dj = larg*j;
			hh = dj+dh;
			for (var i=-h1;i<=h1;i++) {
				c_case(dv+i*larg, hh);
			}
			c_case(dv, hh);//axe x
			c_case(dv+dj, dh);//axe y
			//etiquettes texte
			p_txt(ec[0], ec[1]+dj, j+x1);//haut
			p_txt(ec[2]+dj, ec[3], y1-j);//gauche
			p_txt(ec[4], ec[5]+dj, j+x1);//bas
			p_txt(ec[6]+dj, ec[7], y1-j);//droite
		}

		if((x1 != posx || y1 != posy) && posx > xmin && posx < xmax && posy > ymin && posy < ymax) c_case(dv+(y1-posy)*larg, dh+(posx-x1)*larg);
	}
	else {
		dessin  = document.createElement("canvas");
		dessin.width = taille;
		dessin.height = taille;
		dessin.style.top = decal_v+"px";
		dessin.style.left = decal_h+"px";
		dessin.id = "grille";
		ancre.appendChild(dessin);
		dessin = document.getElementById("grille");

		if (dessin.getContext){
			var ctx = dessin.getContext("2d");
			ctx.strokeStyle="rgb(183,161,140)";
			ctx.fillStyle="rgba(216,194,173,0.33)";

			milieu = h1*larg;

			ctx.fillRect(0,0,taille,taille);
			ctx.fillRect(0,milieu ,taille,larg);
			ctx.fillRect(milieu ,0,larg,taille);
			ctx.strokeRect(0,0,taille,taille);

			ctx.beginPath();
			for (var j=0;j<=2*h1;j++) {//grille
				dj = larg*j;
				ctx.moveTo(dj, 0);
				ctx.lineTo(dj, taille-1);
				ctx.moveTo(0, dj);
				ctx.lineTo(taille-1, dj);
			}
			ctx.stroke();
		}
	}
	ec = [decal_v-18, parseInt(dh+.5*larg-6), parseInt(dv+.5*larg-7), decal_h-25, dv+h1*larg+1*larg+3, parseInt(dh+.5*larg-6), parseInt(dv+.5*larg-7), dh+h1*larg+1*larg+3];
	for (var j=-h1;j<=h1;j++) {//grille
		dj = larg*j;
		p_txt(ec[0], ec[1]+dj, j+x1);//haut
		p_txt(ec[2]+dj, ec[3], y1-j);//gauche
		p_txt(ec[4], ec[5]+dj, j+x1);//bas
		p_txt(ec[6]+dj, ec[7], y1-j);//droite
	}
}
//Place les icones
function calc_coord(px,py,pn,cat,lign,nom) {
	if(!coord[cat][px]) {
		coord[cat][px] = new Array();
		coord[cat][px][py] = new Array();
		coord[cat][px][py][pn] = [[lign,nom]];
		return;
	}
	else if(!coord[cat][px][py]) {
		coord[cat][px][py] = new Array();
		coord[cat][px][py][pn] = [[lign,nom]];
		return;
	}
	else if(!coord[cat][px][py][pn]) {
		coord[cat][px][py][pn] = [[lign,nom]];
		return;
	}
	else {
		coord[cat][px][py][pn].push([lign,nom]);
	}
}
function p_ico(px,py,pn,lien,nom,ref,cat) {
	if(px < xmin || px > xmax || py < ymin || py > ymax || pn < nmin || pn > nmax) return;
	(document.getElementById("NS"+pn)).appendChild(p_ico_b(px,py,pn,lien,nom,ref,cat));
}
function p_ico_m(px,py,pn,lien,nom,ref) {
	if(px < xmin || px > xmax || py < ymin || py > ymax || pn < nmin || pn > nmax) return;
	if(coord[0][px] && coord[0][px][py] && coord[0][px][py][pn]) {
		compte["i_moqp"]++;
		(document.getElementById("NS_moqp"+pn)).appendChild(p_ico_b(px,py,pn,lien,nom,ref,1));
	}
	else {
		(document.getElementById("NS"+pn)).appendChild(p_ico_b(px,py,pn,lien,nom,ref,1));
	}
}
function p_ico_o(px,py,pn,lien,nom,ref) {
	if(px < xmin || px > xmax || py < ymin || py > ymax || pn < nmin || pn > nmax) return;
	if(coord[0][px] && coord[0][px][py] && coord[0][px][py][pn]) {
		compte["i_ooqp"]++;
		(document.getElementById("NS_ooqp"+pn)).appendChild(p_ico_b(px,py,pn,lien,nom,ref,2));
	}
	else {
		(document.getElementById("NS"+pn)).appendChild(p_ico_b(px,py,pn,lien,nom,ref,2));
	}
}
function p_ico_b(px,py,pn,lien,nom,ref,cat) {
	nom = ["i_t","i_m","i_o","i_l","i_c"][cat]+nom;
	calc_coord(px,py,pn,cat,ref,nom)
	compte[nom]++;
	imag=document.createElement("img");
	imag.className = "icone "+nom;
	imag.src=chemin+["i_t","i_m","i_o","i_l","i_c"][cat]+lien+".png";
	imag.style.top = (dy-larg*py)+"px"; imag.style.left = (dx+larg*px)+"px";
	imag.alt="";
	imag.id=["i_t","i_m","i_o","i_l","i_c"][cat]+ref;
	imag.name=nom;
	return imag;
}

function icones() {//l : dcalage gauche sur case, c : dcalage haut, en px
	//trolls
	for(var k=0; k<5; k++) { coord[k] = new Array(); }
	demi = larg - opt["ico"]; tiers = Math.floor(opt["ico"] * 0.75);
	if(nb_t) {
		l=1; c=1; dx = c-x1*larg+dh; dy = dv+l+y1*larg;
		xxx = x_t[0].childNodes.length-3; yyy = x_t[0].childNodes.length-2; nnn = x_t[0].childNodes.length-1;
		for (var i=1;i<nb_t;i++) {
			statut = "n";
			if(x_t[i].className == "mh_trolls_amis" || x_t[i].className == "mh_guildes_amis" || x_t[i].style.backgroundColor == "rgb(170, 255, 170)") statut = "a";
			else if(x_t[i].className == "mh_trolls_ennemis" || x_t[i].className == "mh_guildes_ennemis" || x_t[i].style.backgroundColor == "rgb(255, 170, 170)") statut = "e";
			else if(x_t[i].className == "mh_guildes_perso" || x_t[i].style.backgroundColor == "rgb(187, 187, 255)") statut = "p";
			else if(x_t[i].getElementsByTagName("a")[0].className == "mh_trolls_0") statut = "i";

			p_ico(parseInt(x_t[i].childNodes[xxx].firstChild.nodeValue), parseInt(x_t[i].childNodes[yyy].firstChild.nodeValue), parseInt(x_t[i].childNodes[nnn].firstChild.nodeValue), statut, statut, i, 0);
		}
	}
	//monstres
	if(nb_m > 1) {
		l=1;c=demi; dx = c-x1*larg+dh; dy = dv+l+y1*larg;
		xxx = x_m[0].childNodes.length-3; yyy = x_m[0].childNodes.length-2; nnn = x_m[0].childNodes.length-1;
		mm = (x_m[1].childNodes[2].getElementsByTagName("a").length > 0)? 2:3;
		for (var i=1;i<nb_m;i++) {
			if(x_m[i].childNodes.length < 3) continue;
			statut = "";
			if(x_m[i].childNodes[mm].innerHTML.indexOf("Gowap Apprivois") != -1) statut = "g";
			p_ico_m(parseInt(x_m[i].childNodes[xxx].firstChild.nodeValue), parseInt(x_m[i].childNodes[yyy].firstChild.nodeValue), x_m[i].childNodes[nnn].firstChild.nodeValue, statut, statut, i);
		}
	}
	//item
	l=demi;c=1; dx = c-x1*larg+dh; dy = dv+l+y1*larg; statut2 = "";
	for (var i=1;i<nb_o;i++) {
		statut = ""; nom = x_o[i].childNodes[2].innerHTML;
		if(nom.indexOf("Potion") != -1) statut = "p";
		else if(nom.indexOf("Composant") != -1) statut = "c";
		else if(nom.indexOf("Gigots de Gob") != -1) statut = "g";
		else if(nom.indexOf("Champignon") != -1) statut = "ch";
		else if(nom.indexOf("Armure") != -1) statut = "oa";
		else if(nom.indexOf("Arme (1 main)") != -1) statut = "oa1";
		else if(nom.indexOf("Arme (2 mains)") != -1) statut = "oa2";
		else if(nom.indexOf("Casque") != -1) statut = "oc";
		else if(nom.indexOf("Talisman") != -1) statut = "ot";
		else if(nom.indexOf("Bouclier") != -1) statut = "oe";
		else if(nom.indexOf("Bottes") != -1) statut = "ob";
		else if(nom.indexOf("Anneau") != -1) statut = "a";
		else if(nom.indexOf("Parchemin") != -1) statut = "e";
		else if(nom.indexOf("carte") != -1) statut = "ca";
		else if(nom.indexOf("Minerai") != -1) statut = "m";
		// else if(nom.indexOf("Spcial" || x_o[i].getElementsByTagName("a").length > 0) statut = "";
		if(opt["spec_obj"]) statut2 = statut;
		p_ico_o(parseInt(x_o[i].childNodes[3].firstChild.nodeValue), parseInt(x_o[i].childNodes[4].firstChild.nodeValue), x_o[i].childNodes[5].firstChild.nodeValue, statut2, statut, i);
	}
	//lieux
	l=demi;c=demi; dx = c-x1*larg+dh; dy = dv+l+y1*larg; statut2 = "";
	for (var i=1;i<nb_l;i++) {
		statut = ""; nom = x_l[i].childNodes[2].innerHTML;
		if(x_l[i].getElementsByTagName("a").length > 0) statut = "t";
		else if(nom.indexOf("Trou de Mtorite") != -1) statut = "tm";
		else if(nom.indexOf("Portail de Tlportation") != -1) statut = "p";
		else if(nom.indexOf("Sortie de Portail") != -1) statut = "s";
		else if(nom.match(/Couvoir|Terrier|Cocon|Porte d'Outre-Monde|Nid|Portail Dmoniaque/)) statut = "m";
		else if(nom.match(/Gowapier|Refuge|Forge|Agence d'Annonce|Boutique d'Enchantement|Cahute du Rmouleur|Lice|Armurerie|Source de Purification|Auberge|Malfacterie|Marabouterie|Minroll|Spulcre|Bureau des Primes|Tlporteur/)) statut = "c";
		if(opt["spec_lieux"]) statut2 = statut;
		p_ico(parseInt(x_l[i].childNodes[3].firstChild.nodeValue),parseInt(x_l[i].childNodes[4].firstChild.nodeValue), x_l[i].childNodes[5].firstChild.nodeValue, statut2, statut, i, 3);
	}
	//champ
	l=tiers;c=tiers; dx = c-x1*larg+dh; dy = dv+l+y1*larg;
	for (var i=1;i<nb_c;i++) {
		p_ico(parseInt(x_c[i].childNodes[3].firstChild.nodeValue), parseInt(x_c[i].childNodes[4].firstChild.nodeValue), x_c[i].childNodes[5].firstChild.nodeValue, "", "", i, 4);
	}
}
///////////////////////////////////////////////////////////////////////////
//Utilisation de la map

////////////////////////////////
//Affichage des info d'un case dans une infobox
function get_desc(cat,xx,yy,fonct) {
	if(coord[cat][xx] && coord[cat][xx][yy]) {
		for (var i in coord[cat][xx][yy]) {
			for (var j in coord[cat][xx][yy][i]) {
				descase[i] += "<img src='"+chemin+coord[cat][xx][yy][i][j][1]+".png' alt='' /> ["+fonct(coord[cat][xx][yy][i][j][0])+"<br />";
			}
		}
	}
}

function c_txt(xx,yy) {
	document.getElementById("bulle_desc").innerHTML = "";

	descase = new Array();
	for (var j=nmin;j<=nmax;j++) { descase[j]=""; }
	get_desc(0,xx,yy,troll);
	get_desc(1,xx,yy,monst);
	get_desc(2,xx,yy,item);
	get_desc(3,xx,yy,lieu);
	get_desc(4,xx,yy,champ);

	i = 0;
	for (var j=nmax;j>=nmin;j--) {
		if (descase[j] != "") {
			nvdiv = document.createElement("div");
			nvdiv.className = (i%2)? "bulle_desc_impair":"bulle_desc";
			nvspan = document.createElement("span");
			nvspan.className = (j==n1)? "meme_niv":"autre_niv";
			nvspan.appendChild(document.createTextNode("n = "+j+", distance : "+Math.max(Math.abs(xx-x1),Math.abs(yy-y1),Math.abs(j-n1))+" "));
			imag = illustr("centrer.png","Excentrer la vue","Excentrer");
			imag.id = "centre_"+xx+"_"+yy+"_"+j;
			imag.className = "excentrer";
			addEvent(imag, "click", function() { excentrer(this.id) }, true);
			nvspan.appendChild(imag);
			nvdiv.appendChild(nvspan);
			divdesc = document.createElement("div");
			divdesc.innerHTML = descase[j];
			nvdiv.appendChild(divdesc);
			document.getElementById("bulle_desc").appendChild(nvdiv);
			i++;
		}
	}
}
function troll(i) {
	if(x_t[i].getElementsByTagName("input").length > 0) {
		return x_t[i].childNodes[1].innerHTML+"] "+x_t[i].childNodes[3].innerHTML+" "+x_t[i].childNodes[6].innerHTML+" "+x_t[i].childNodes[5].innerHTML+" "+x_t[i].childNodes[4].innerHTML;
	}
	else {
		return  x_t[i].childNodes[1].innerHTML+"] "+x_t[i].childNodes[2].innerHTML+" "+x_t[i].childNodes[5].innerHTML+" "+x_t[i].childNodes[4].innerHTML+" "+x_t[i].childNodes[3].innerHTML;
	}
}
function monst(i) {
	return x_m[i].childNodes[1].innerHTML+"] "+((x_m[1].childNodes[3].getElementsByTagName("a").length > 0)? x_m[i].childNodes[3].innerHTML+" ":"")+x_m[i].childNodes[2].innerHTML;
}
function lieu(i) {
	return x_l[i].childNodes[1].innerHTML+"] "+x_l[i].childNodes[2].innerHTML;
}
function item(i) {
	return x_o[i].childNodes[1].innerHTML+"] "+x_o[i].childNodes[2].innerHTML;
}
function champ(i) {
	return x_c[i].childNodes[1].innerHTML+"] "+x_c[i].childNodes[2].innerHTML;
}
function excentrer(pt,evt) {
	if(!opt["ouvre_dist"] && evt != undefined) return;
	pt = pt.split("_");
	x1 = parseInt(pt[1]);
	y1 = parseInt(pt[2]);
	n1 = parseInt(pt[3]);

	if(x1 !== cold[0] || y1 != cold[1] || n1 != cold[2]) {
		if(!vue_cree) {
			h1 = Math.min(opt_val("h",vueh),vueh+Math.max(Math.abs(x1-posx),Math.abs(y1-posy)));
			v1 = Math.min(opt_val("v",vuev),vuev+Math.abs(n1-posn));
			creer_vue(); creer_bulle_vue(); poser_vue(evt); ini_popup(); init_evenement_v();
		}
		else {
			h1 = Math.min(h1,vueh+Math.max(Math.abs(x1-posx),Math.abs(y1-posy)));
			v1 = Math.min(v1,vuev+Math.abs(n1-posn));

			if(evt != undefined) poser_vue(evt);
			ini_popup();
		}
	}
}
////////////////////////////////
//Afficher/Effacer info
//selection des profondeurs
function etag() {
	ref = this.id;
	(document.getElementById("N"+ref)).style.display= (vu[ref])? "none":"";
}
function etago() {
	ref = this.id;
	(document.getElementById("N"+ref)).style.display= (vu[ref])? "":"none";
}
function etagc() {
	ref = this.id;
	vu[ref] = !vu[ref];
	if (vu[ref]) {
		(document.getElementById("N"+ref)).style.display= "";
		(document.getElementById(ref)).className="niv";
	}
	else {
		(document.getElementById("N"+ref)).style.display= "none";
		(document.getElementById(ref)).className="niv_out";
	}
}
function tous() {
	for (var j in vu) {
		vu[j] = true;
		(document.getElementById("N"+j)).style.display="";
		(document.getElementById(j)).className="niv";
	}
}
function aucun() {
	for (var j in vu) {
		vu[j] = false;
		(document.getElementById("N"+j)).style.display="none";
		(document.getElementById(j)).className="niv_out";
	}
}

//////////////////////
//options d'affichage
//creation des entrees
function aj_opt(ref,desc) {
	nvspan = aligne();
	choix = document.createElement("input");
	choix.id = ref;
	choix.type = "checkbox";
	choix.checked = opt[ref];
	choix.title = desc;
	etik = document.createElement("label");
	etik.appendChild(illustr(ref+".png",desc,desc));
	etik.htmlFor = ref;
	nvspan.appendChild(choix);
	nvspan.appendChild(etik);
	return nvspan;
}
function aj_opt_fptt(ref,desc) {
	nvspan = aligne();
	choix = document.createElement("input");
	choix.id = ref;
	choix.type = "checkbox";
	choix.checked = opt[ref];
	choix.title = desc;
	etik = document.createElement("label");
	etik.appendChild(document.createTextNode(desc));
	etik.htmlFor = ref;
	nvspan.appendChild(choix);
	nvspan.appendChild(etik);
	return nvspan;
}
function aj_opt_base(ref, desc, modif_opaq) {
	sp = aj_opt(ref,desc);
	addEvent(sp.firstChild, "click", function() { alterne_ico(this.id,this.checked) }, true);
	addEvent(sp, "mouseover", function() { encadre(this.firstChild.id, true, modif_opaq) }, true);
	addEvent(sp, "mouseout",  function() { encadre(this.firstChild.id, false, modif_opaq) }, true);
	return sp;
}
function aj_spec_obj() {
	sp = aj_opt_fptt("spec_obj","Objets");
	addEvent(sp.firstChild, "click", specifier_obj, true);
	return sp;
}
function aj_spec_lieux() {
	sp = aj_opt_fptt("spec_lieux","Lieux");
	addEvent(sp.firstChild, "click", specifier_lieux, true);
	return sp;
}
function aj_entree(ref,val) {
	entree = document.createElement("input");
	entree.id = ref;
	entree.name = ref;
	entree.className = "TextboxV2";
	entree.size = "5";
	entree.value = val;
	return entree;
}
function aj_alterne_ico(ref, desc, noeud) {
	if(compte[ref] > 0) noeud.appendChild(aj_opt_base(ref,desc+" ("+compte[ref]+")",true));
}
function aj_alterne_ico_oqp(ref, desc, noeud) {
	if(compte[ref] > 0) noeud.appendChild(aj_opt_base(ref,desc+" ("+compte[ref]+")",false));
}
//cration des options
function creer_opt() {
	opt_vue.innerHTML = "";
	i = 0
	if(nb_t > 1) {
		spanchoix = document.createElement("span");
		spanchoix.className = (i%2)? "gp_choix_impair":"gp_choix";
		lst = [["a","Trlls allis"],["p","Guilde"],["n","Trlls neutres"],["e","Trlls ennemis"],["i","Trlls intangibles"]]
		for(var j in lst) {
			aj_alterne_ico("i_t"+lst[j][0], lst[j][1], spanchoix);
		}
		opt_vue.appendChild(spanchoix);
		espacer(opt_vue);
		i++;
	}
	if(nb_m > 1) {
		spanchoix = document.createElement("span");
		spanchoix.className = (i%2)? "gp_choix_impair":"gp_choix";
		aj_alterne_ico("i_m", "Monstres", spanchoix);
		aj_alterne_ico("i_mg", "Gowaps Apprivoiss", spanchoix);
		aj_alterne_ico_oqp("i_moqp", "Monstres occups", spanchoix);
		opt_vue.appendChild(spanchoix);
		espacer(opt_vue);
		i++;
	}
	if(nb_o > 1) {
		spanchoix = document.createElement("span");
		spanchoix.className = (i%2)? "gp_choix_impair":"gp_choix";
		lst = [["a","Anneau"],["ca","Carte"],["ch","Champignons"],["c","Composants"],["oa1","Arme  1 main"],["oa2","Arme  2 mains"],["oa","Armure"],["ob","Bottes"],["oe","Bouclier"],["oc","Casque"],["ot","Talisman"],["g","Gigots de gob"],["m","Minerais"],["e","Parchemins"],["p","Potions"],["","Objets Divers"]]
		for(var j in lst) {
			aj_alterne_ico("i_o"+lst[j][0], lst[j][1], spanchoix);
		}

		aj_alterne_ico_oqp("i_ooqp", "Trsors occups", spanchoix);
		opt_vue.appendChild(spanchoix);
		espacer(opt_vue);
		i++;
	}
	if(nb_c > 1) {
		spanchoix = document.createElement("span");
		spanchoix.className = (i%2)? "gp_choix_impair":"gp_choix";
		aj_alterne_ico("i_c", "Champignons", spanchoix);
		opt_vue.appendChild(spanchoix);
		espacer(opt_vue);
		i++;
	}
	if(nb_l > 1) {
		spanchoix = document.createElement("span");
		spanchoix.className = (i%2)? "gp_choix_impair":"gp_choix";
		lst = [["t","Tanires"],["tm","Trous de mtorites"],["p","Portails de Tlportation"],["s","Sorties de Portail"],["c","Services"],["m","Nids de monstre"],["","Divers"]]
		if(parNom("i_l").length < nb_l-1) {
			for(var j in lst) {
				aj_alterne_ico("i_l"+lst[j][0], lst[j][1], spanchoix);
			}
		}
		opt_vue.appendChild(spanchoix);
		espacer(opt_vue);
		i++;
	}

	opt_crees = true;
	if(ie) {
		etik = ["i_ta","i_tp","i_tn","i_te","i_ti","i_m","i_mg","i_moqp","i_oc","i_ooa","i_ooa1","i_ooa2","i_oob","i_ooc","i_ooe","i_oot","i_og","i_oe","i_op","i_o","i_ooqp","i_c","i_om","i_oa","i_oca","i_l","i_lt","i_lp","i_ls","i_ltm","i_lc","i_lm","spec_obj","spec_lieux","ouvre_dist","opaque"];
		for(var j in etik) {
			if(document.getElementById(etik[j])) document.getElementById(etik[j]).checked = opt[etik[j]];
		}
	}
}
function creer_opt_spe() {
	divchoix = document.createElement("div");
	espacer(divchoix);
	divchoix.className = "gp_choix";
	divchoix.appendChild(document.createTextNode("Icnes\u00a0spcifiques\u00a0:\u00a0"));
	divchoix.appendChild(aj_spec_obj());
	divchoix.appendChild(aj_spec_lieux());
	opt_vue_spe.appendChild(divchoix);

	divchoix = document.createElement("div");
	espacer(divchoix);
	divchoix.className = "gp_choix";
	divchoix.appendChild(document.createTextNode("Ressources\u00a0:\u00a0"));
	choix = aj_entree("opt_pack", pack);
	addEvent(choix, "keyup", function() { regle_chemin(this.value) }, true);
	addEvent(choix, "change", function() { regle_chemin(this.value) }, true);
	choix.size = "70";
	divchoix.appendChild(choix);
	opt_vue_spe.appendChild(divchoix);

	divchoix = document.createElement("div");
	divchoix.id = "o_opaque";
	espacer(divchoix);
	divchoix.className = "gp_choix";
	divchoix.appendChild(insert_texte("Opacit\u00a0des\u00a0icnes\u00a0:\u00a0"));
	divchoix.appendChild(creer_glissiere("opacite"));
	divchoix.appendChild(insert_texte("\u00a0"));
	choix = aj_entree("opt_opaque", opt["opaque"]);
	addEvent(choix, "keyup", function() { alterne_opaque(this.value) }, true);
	addEvent(choix, "change", function() { alterne_opaque(this.value) }, true);
	divchoix.appendChild(choix);
	divchoix.appendChild(insert_texte("\u00a0%"));
	opt_vue_spe.appendChild(divchoix);

	divchoix = document.createElement("div");
	divchoix.id = "o_taille";
	espacer(divchoix);
	divchoix.className = "gp_choix";
	divchoix.appendChild(insert_texte("Taille\u00a0des\u00a0icnes\u00a0:\u00a0"));
	divchoix.appendChild(creer_glissiere("ico"));
	divchoix.appendChild(insert_texte("\u00a0"));
	choix = aj_entree("opt_taille_ico", opt["ico"]);
	addEvent(choix, "keyup", function() { regle_taille(this.value) }, true);
	addEvent(choix, "change", function() { regle_taille(this.value) }, true);
	divchoix.appendChild(choix);
	divchoix.	appendChild(insert_texte("\u00a0px\u00a0"));
	exemple = illustr("i_tn.png", "Exemple", "");
	exemple.id = "exemple_ico";

	divchoix.appendChild(exemple);
	divchoix.appendChild(insert_texte("\u00a0"));
	actu = illustr("actu.png", "Actualiser l'affichage", "Actualiser");
	raz = illustr("raz.png", "Remise  zro", "RAZ");
	actu.id = "actu";
	actu.className = "a_cliquer";
	raz.className = "a_cliquer";
	addEvent(actu, "click", actu_param, true);
	addEvent(raz, "click", raz_param, true);
	divchoix.appendChild(raz);
	divchoix.appendChild(actu);
	opt_vue_spe.appendChild(divchoix);

	ex_ico(opt["ico"]);
	positionne_curseur("opacite", opt["opaque"]);
}
//actions des options
function creer_glissiere(ref) {
	glissiere = document.createElement("div");
	glissiere.className = "glissiere";
	glissiere_fond = bloc("glissiere_opt_"+ref);
	addEvent(glissiere_fond , "click", function(evt) { click_glissiere(this.id,evt) }, true);
	glissiere_fond.innerHTML = " ";
	glissiere_fond.className = "glissiere_fond";
	glissiere.appendChild(glissiere_fond);
	curseur = bloc("curseur_opt_"+ref);
	curseur.innerHTML = " ";
	curseur.className = "curseur";
	glissiere.appendChild(curseur);
	return glissiere;
}
function alterne_ico(ref,coche) {
	opt[ref] = coche;
	if(opt_crees) sauver_opt();
	try {
		document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.display = coche? "inline":"none";
	}
	catch(e) {
		document.styleSheets["style_fptt"].rules[classes[ref]].style.display = coche? "inline":"none";
	}

}
function encadre(ref, dessus,modif_opaq) {
	try {
		if (dessus) {
			document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.zIndex = "630";
			if (modif_opaq) document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.opacity = "1.0";
			document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.display = "inline";
		}
		else {
			document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.zIndex = "620";
			if (modif_opaq) document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.opacity = parseFloat(opt["opaque"])/100.0;
			document.getElementById("style_fptt").sheet.cssRules[classes[ref]].style.display = opt[ref]? "inline":"none";
		}
	}
	catch(e) {
		if (dessus) {
			document.styleSheets["style_fptt"].rules[classes[ref]].style.zIndex = "630";
			if (modif_opaq) document.styleSheets["style_fptt"].rules[classes[ref]].style.filter = "alpha(opacity=100)";
			document.styleSheets["style_fptt"].rules[classes[ref]].style.display = "inline";
		}
		else {
			document.styleSheets["style_fptt"].rules[classes[ref]].style.zIndex = "620";
			if (modif_opaq) document.styleSheets["style_fptt"].rules[classes[ref]].style.filter = "alpha(opacity="+opt["opaque"]+")";
			document.styleSheets["style_fptt"].rules[classes[ref]].style.display = "inline";
		}
	}
}
function specifier_lieux() {
	opt["spec_lieux"] = this.checked;
	sauver_opt();
	lst_etik = ["t","tm","p","s","c","m",""];
	if(opt["spec_lieux"]) {
		for(var j in lst_etik) {
			lst = parNom("i_l"+lst_etik[j]);
			for(var i in lst) { lst[i].src = chemin+"i_l"+lst_etik[j]+".png"; }
		}
	}
	else {
		for(var j in lst_etik) {
			lst = parNom("i_l"+lst_etik[j]);
			for(var i in lst) { lst[i].src = chemin+"i_l"+".png"; }
		}
	}
}
function specifier_obj() {
	opt["spec_obj"] = this.checked;
	sauver_opt();
	lst_etik = ["c","oa","oa1","oa2","ob","oc","oe","ot","g","e","p","m","ch","ca","a",""];
	if(opt["spec_obj"]) {
		for(var j in lst_etik) {
			lst = parNom("i_o"+lst_etik[j]);
			for(var i in lst) { lst[i].src = chemin+"i_o"+lst_etik[j]+".png"; }
		}
	}
	else {
		for(var j in lst_etik) {
			lst = parNom("i_o"+lst_etik[j]);
			for(var i in lst) { lst[i].src = chemin+"i_o"+".png"; }
		}
	}
}
function regle_taille(valeur) {
	valeur = (isNaN(valeur))? 12:parseInt(valeur);

	if(!ie) {
		ancre.style.MozTransform = "scale("+(parseFloat(valeur)/ico_ref)+")";
		ancre.style.WebkitTransform = "scale("+(parseFloat(valeur)/ico_ref)+")";
		ancre.style.transform = "scale("+(parseFloat(valeur)/ico_ref)+")";

		style_ancre = window.getComputedStyle(ancre, null);
		if(style_ancre.MozTransform || style_ancre.WebkitTransform || style_ancre.transform) {
			popup_vue.style.width = Math.max((2*h1+1)*(Math.ceil(2.5*valeur)-2)+70,168+76*v1,250)+"px";
			ancre.style.height =((2*h1+1)*(Math.ceil(2.5*valeur)-2)+60)+"px";
			opt["ico"] = valeur;
			sauver_opt();
			document.getElementById("exemple_ico").style.display = "none";
			positionne_curseur("ico",Math.floor(100.0*(parseFloat(valeur)-5.0)/45.0));
		}
		else {
			ex_ico(valeur);
		}
	}
	else {
		ex_ico(valeur);
	}
}
function ex_ico(val) {
	document.getElementById("exemple_ico").style.width = val+"px";
	document.getElementById("exemple_ico").style.height = val+"px";
	document.getElementById("o_taille").style.height = Math.max(val+2,22)+"px";
	positionne_curseur("ico",Math.floor(100.0*(parseFloat(val)-5.0)/45.0));
}
function regle_chemin(valeur) {
	if(valeur) {
		if(trim(valeur) && trim(valeur) != pack) {
			document.getElementById("actu").src = definir_chemin(trim(valeur))+"actu.png";
		}
	}
}
function alterne_opaque(opacite) {
	if(isNaN(opacite)) {
		opacite = 25;
	}
	else {
		opacite = Math.min(100,Math.max(0,parseInt(opacite)));
	}
	if(opt["opaque"] == opacite) return;
	opt["opaque"] = opacite;
	sauver_opt();
	positionne_curseur("opacite",opacite);
	applique_opacite();
}
function click_glissiere(ref,evt ) {
		if (evt.offsetX) {
			xpage = evt.offsetX;
		}
		else {
			xpage = evt.layerX;
		}
		xpage = Math.min(100,Math.max(0,xpage));
		ref = ref.split("_")[2];
		valeur_curseur(ref, xpage);
}
function valeur_curseur(ref,valeur) {
	if(ref == "opacite") {
		set_opt("opt_opaque",valeur);
		alterne_opaque(valeur);
	}
	else {
		valeur = 5+Math.floor(valeur/100.0*45.0);
		set_opt("opt_taille_ico",valeur);
		regle_taille(valeur);
	}
}
function actu_param() {
	if(isNaN(get_opt("opt_taille_ico"))) {
		taille_i = opt["ico"];
	}
	else {
		taille_i = parseInt(get_opt("opt_taille_ico"));
	}
	if(get_opt("opt_pack")) {
		pack2 = trim(get_opt("opt_pack"))
	}
	else {
		pack2 = pack;
	}

	refaire = false;
	if(taille_i != opt["ico"]) {
		refaire = true;
		opt["ico"] = taille_i;
		sauver_opt();
	}
	else if(ico_ref != opt["ico"]) {
		refaire = true;
	}
	if(pack != pack2) {
		refaire = true;
		applique_chemin(pack2);
	}
	if(refaire) ini_popup();
}
function raz_param() {
	refaire = false;
	if(opt["ico"] != 12) {
		refaire = true;
		opt["ico"] = 12;
		sauver_opt();
		set_opt("opt_taille_ico",12);
		ex_ico(12);
	}
	if(pack != "http://feldspath.free.fr/feldspatatrac/") {
		refaire = true;
		applique_chemin("http://feldspath.free.fr/feldspatatrac/");
		set_opt("opt_pack",pack);
	}
	if(refaire) ini_popup();
}
function applique_chemin(val) {
	pack = val;
	chemin = definir_chemin(val);
	MZ_setValue("FELDSPATATRAC_CHEMIN", val);
	document.getElementById("fichier_style").href = chemin+"fptt.css";
}
function positionne_curseur(ref,valeur) {
	document.getElementById("curseur_opt_"+ref).style.left = Math.min(Math.max(0,valeur),100)+"px";
}
function definir_chemin(chaine) {
	if(chaine.toLowerCase().indexOf("http://") == 0) { chem = trim(chaine); }
	else { chem = trim("file://"+chaine.replace(/\\/g,"/")); }
	if(chem.substr(chem.length-1,1) != "/") chem +="/";
	return chem;
}
function applique_opacite() {
	liste = ["i_ta","i_tp","i_tn","i_te","i_ti","i_m","i_mg","i_oc","i_och","i_oob","i_og","i_oe","i_op","i_o","i_c","i_om","i_l","i_lt","i_lp","i_ls","i_ltm","i_lc","i_lm","i_ooa","i_ooa1","i_ooa2","i_ooc","i_ooe","i_oot","i_oa","i_oca"];

	try {
		ligne = 3;
		for (var i in liste) {
			document.getElementById("style_fptt").sheet.cssRules[ligne].style.opacity = parseFloat(opt["opaque"])/100.0;
			ligne++;
		}
	}
	catch(e) {
		ligne = 4;
		for (var i in liste) {
			document.styleSheets["style_fptt"].rules[ligne].style.filter = "alpha(opacity="+opt["opaque"]+")";
			ligne++;
		}
	}
}
function ini_css() {
	styl = document.createElement("style");
	styl.id = "style_fptt";
	styl.type = "text/css";
	document.getElementsByTagName("head")[0].appendChild(styl);
	liste = ["i_ta","i_tp","i_tn","i_te","i_ti","i_m","i_mg","i_oc","i_och","i_oob","i_og","i_oe","i_op","i_o","i_c","i_om","i_l","i_lt","i_lp","i_ls","i_ltm","i_lc","i_lm","i_ooa","i_ooa1","i_ooa2","i_ooc","i_ooe","i_oot","i_oa","i_oca"];
	try {
		opa = parseFloat(opt["opaque"])/100.0;
		document.getElementById("style_fptt").sheet.insertRule(".icone { width : "+opt["ico"]+"px; height : "+opt["ico"]+"px;}",0);
		document.getElementById("style_fptt").sheet.insertRule(".i_ooqp { display:"+(opt["i_ooqp"]? "inline":"none")+"; }",1);
		document.getElementById("style_fptt").sheet.insertRule(".i_moqp { display:"+(opt["i_ooqp"]? "inline":"none")+"; }",2);
		classes["i_ooqp"] = 1; classes["i_moqp"] = 2;
		ligne = 3;
		for (var i in liste) {
			document.getElementById("style_fptt").sheet.insertRule("."+liste[i]+" { opacity : "+opa+"; display:"+(opt[liste[i]]? "inline":"none")+"; }",ligne);
			classes[liste[i]] = ligne;
			ligne++;
		}
	}
	catch(e) {
		document.styleSheets["style_fptt"].addRule(".icone", "width : "+opt["ico"]+"px; height : "+opt["ico"]+"px;", 0);
		document.styleSheets["style_fptt"].addRule(".case", "width : "+(larg+1)+"px; height : "+(larg+1)+"px;", 1);
		document.styleSheets["style_fptt"].addRule(".i_ooqp", "display:"+(opt["i_ooqp"]? "inline":"none")+";", 2);
		document.styleSheets["style_fptt"].addRule(".i_moqp", "display:"+(opt["i_moqp"]? "inline":"none")+";", 3);
		classes["i_ooqp"] = 2; classes["i_moqp"] = 3;
		ligne = 4;
		for (var i in liste) {
			document.styleSheets["style_fptt"].addRule("."+liste[i], "filter : alpha(opacity="+opt["opaque"]+"); display:"+(opt[liste[i]]? "inline":"none")+";",ligne);
			classes[liste[i]] = ligne;
			ligne++;
		}
	}
}
///////////
//Popup Vue
function afficher_vue(evt) {
	x1 = opt_val("x",posx);
	y1 = opt_val("y",posy);
	n1 = opt_val("n",posn);
	if (x1 < posx-vueh) x1 = posx-vueh;
	if (x1 > posx+vueh) x1 = posx+vueh;
	if (y1 > posy+vueh) y1 = posy+vueh;
	if (y1 < posy-vueh) y1 = posy-vueh;
	if (n1 < posn-vuev) n1 = posn-vuev;
	if (n1 > posn+vuev) n1 = posn+vuev;
	opt["h"] = opt_val("h",vueh); opt["v"]= opt_val("v",vuev); sauver_opt();
	h1 = Math.min(opt["h"],vueh+Math.max(Math.abs(x1-posx),Math.abs(y1-posy)));
	v1 = Math.min(opt["v"],vuev+Math.abs(n1-posn));

	if(!vue_cree) {
		creer_vue(); creer_bulle_vue(); poser_vue(evt); ini_popup(); init_evenement_v();
	}
	else if(x1 !== cold[0] || y1 != cold[1] || n1 != cold[2] || h1 != cold[3] || v1 != cold[4]) {
		poser_vue(evt); ini_popup();
		document.getElementById("popup_vue").style.display = "";
	}
	else {
		document.getElementById("popup_vue").style.display = "";
		document.getElementById("contenu_vue").style.display = "";
	}
	if(vue_reduite) alterner_voir();// }catch(e) {alert(e) }
}
function creer_vue() {
	//Cration de la popup
	pu_vue = bloc("popup_vue");

	mobile_vue = bloc("mobile_vue");
	reduc = illustr("moins.png","Reduire la vue","Reduire");
	addEvent(reduc, "click", alterner_voir, true);
	reduc.id = "reduire_vue";
	fermer = illustr("fermer.png","Fermer la vue","Fermer");
	addEvent(fermer, "click", cacher_vue, true);
	fermer.id = "fermer_vue";
	param = illustr("param.png","Paramtres avancs","Paramtres");
	addEvent(param, "click", alterne_param, true);
	param.id = "param_vue";
	mobile_vue.appendChild(reduc);
	mobile_vue.appendChild(enligne("titre_vue"));
	mobile_vue.appendChild(fermer);
	mobile_vue.appendChild(param);

	contenu = bloc("contenu_vue");
	contenu.className = "mh_tdpage";
	contenu.appendChild(bloc("selecteur"));
	contenu.appendChild(bloc("opt_vue"));
	formulaire = document.createElement("form");
	formulaire.id = "opt_vue_spe";
	formulaire.name = "opt_vue_spe";
	formulaire.action = "";
	contenu.appendChild(formulaire);
	contenu.appendChild(bloc("ancre"));

	contenu.appendChild(enligne("chrono"));

	pu_vue.appendChild(mobile_vue);
	pu_vue.appendChild(contenu);
	corps_page.appendChild(pu_vue);

	popup_vue = document.getElementById("popup_vue");
	ancre = document.getElementById("ancre");
	sel = document.getElementById("selecteur");
	opt_vue = document.getElementById("opt_vue");
	opt_vue_spe = document.getElementById("opt_vue_spe");
	if(!opt["opt_spe"]) { opt_vue_spe.style.display = "none"; }
	creer_opt_spe();
	vue_cree = true;
	if(!entetes_crees) creer_entete();
}
function poser_vue(evt) {
	ty = (evt.pageY)? evt.pageY:(evt.clientY + document.body.scrollTop);
	tx = 30;
	popup_vue.style.top = (ty+10)+"px";
	popup_vue.style.left = tx+"px";
}
function cacher_vue() {
	document.getElementById("popup_vue").style.display = "none";
}
function ini_style_popup() {
	ancre.style.MozTransform = "scale(1.0)";
	ancre.style.WebkitTransform = "scale(1.0)";
	ancre.style.transform = "scale(1.0)";
	try {
		document.getElementById("style_fptt").sheet.cssRules[0].style.width = opt["ico"]+"px";
		document.getElementById("style_fptt").sheet.cssRules[0].style.height = opt["ico"]+"px";
		ico_ref = opt["ico"];
	}
	catch(e) {
		document.styleSheets["style_fptt"].rules[0].style.width = opt["ico"]+"px";
		document.styleSheets["style_fptt"].rules[0].style.height = opt["ico"]+"px";
		document.styleSheets["style_fptt"].rules[1].style.width = (larg+1)+"px";
		document.styleSheets["style_fptt"].rules[1].style.height = (larg+1)+"px";
	}
}
function ini_popup() {
	depart();

	liste = ["i_ta","i_tp","i_tn","i_te","i_ti","i_m","i_mg","i_moqp","i_oc","i_och","i_oob","i_og","i_oe","i_op","i_o","i_ooqp","i_c","i_om","i_l","i_lt","i_lp","i_ls","i_ltm","i_lc","i_lm","i_ooa","i_ooa1","i_ooa2","i_ooc","i_ooe","i_oot","i_oa","i_oca"];
	for (var i in liste) {
		compte[liste[i]] = 0;
	}

	ancre.innerHTML = "";
	ini_style_popup();
	larg = Math.ceil(2.5*opt["ico"])-2;
	bulle_vue.style.visibility = "hidden";
	fixe = false;

	coord = new Array(); oqp = new Array();

	document.getElementById("titre_vue").innerHTML = "Vue X="+x1+", Y="+y1+", N="+n1+" ("+h1+"/"+v1+")";
	taille = (2*h1+1)*larg; dh = decal_h+h1*larg; dv = decal_v+h1*larg;
	xmin = x1-h1; xmax = x1+h1;
	ymin = y1-h1; ymax = y1+h1;
	nmin = n1-v1; nmax = Math.min(n1+v1,0);
	cold = [x1, y1, n1, h1, v1];
	popup_vue.style.width = Math.max(taille+70,168+76*v1,250)+"px";
	ancre.style.height = taille+60+"px";
	niveaux(); grille(); icones(); creer_opt(); init_overlay();
	document.getElementById("contenu_vue").style.display="";
	document.getElementById("reduire_vue").src=chemin+"moins.png";
	sauver_opt();
	fin();
}
function alterner_voir() {
	vue_reduite = !vue_reduite
	if(vue_reduite) {
		document.getElementById("contenu_vue").style.display="none";
		document.getElementById("reduire_vue").src=chemin+"plus.png";
	}
	else {
		document.getElementById("contenu_vue").style.display="";
		document.getElementById("reduire_vue").src=chemin+"moins.png";
	}
}
function alterne_param() {
	opt["opt_spe"] = !opt["opt_spe"];
	sauver_opt();
	opt_vue_spe.style.display = (opt["opt_spe"])? "":"none"
}
function depart() {
	chrono = (new Date()).getTime();
}
function fin() {
	temps = (new Date()).getTime()-chrono;
	minutes = Math.floor(temps/60000.0);
	temps = (temps % 60000)/1000.0;
	document.getElementById("chrono").innerHTML = (minutes? minutes+"mn ":"")+String(temps).replace(/\./,",")+"s";
}
////////////
//Bulle info
function creer_bulle_vue() {
	corps_page.appendChild(bloc("popup_bulleVue"));
	bulle_vue = document.getElementById("popup_bulleVue");
	nvdiv = bloc("mobile_bulleVue");
	nvdiv.className = "bulle_haut";
	nvdiv.appendChild(enligne("bulle_haut"));
	fermer = illustr("fermer.png","","Fermer");
	addEvent(fermer, "click", fermer_bulle_vue, true);
	nvdiv.appendChild(fermer);
	bulle_vue.appendChild(nvdiv);
	bulle_vue.appendChild(bloc("bulle_desc"));
}
function init_overlay() {
	masque = bloc("masque");
	masque.style.width = taille+"px";
	masque.style.height = taille+"px";
	masque.style.top = decal_v+"px";
	masque.style.left = decal_h+"px";
	addEvent(masque, "click", alterne_fixe, true);
	addEvent(masque, "mousemove", afficher_case, true);
	addEvent(masque, "mouseout", cacher_bulle, true);
	ancre.appendChild(masque);
}
function afficher_case(evt) {
	if(!fixe) {
		var xpage = 0, ypage = 0, xpos = 0, ypos = 0;

		if (evt.offsetX) {
			xpage = evt.offsetX;
			ypage = evt.offsetY;
			xpos = evt.clientX;
			ypos = evt.clientY + document.body.scrollTop;
		}
		else {
			xpage = evt.layerX;
			ypage = evt.layerY;
			xpos = evt.pageX;
			ypos = evt.pageY;
		}

		if (xpage < taille && xpage > 0 && ypage < taille && ypage > 0) {
			xcase = x1 - h1 + parseInt(xpage/larg);
			ycase = y1 + h1 - parseInt(ypage/larg);
			bulle_vue.style.top = (ypos)+"px";
			bulle_vue.style.left = (xpos+16)+"px";
			bulle_vue.style.visibility = "visible";
			document.getElementById("bulle_haut").innerHTML = "x = "+xcase+", y = "+ycase;
			if (xcase !== xold || ycase != yold) {
				c_txt(xcase,ycase);
				xold = xcase; yold = ycase;
			}
		}
	}
}
function alterne_fixe() {
	fixe = !fixe;
}
function cacher_bulle() {
	if(!fixe) { bulle_vue.style.visibility = "hidden"; }
}
function fermer_bulle_vue() {
	bulle_vue.style.visibility = "hidden";
	fixe = false;
}
///////////////////
//Gestion drag&drop
function init_evenement_v(){
//On commence par affecter une fonction  chaque vnement de la souris
	if(ie){
		document.onmousedown = start_v;
		document.onmousemove = drag_v;
		document.onmouseup = drop_v;
	}
	else{
		document.addEventListener("mousedown",start_v, false);
		document.addEventListener("mousemove",drag_v, false);
		document.addEventListener("mouseup",drop_v, false);
	}
}
function start_v(e){
	//On initialise l'vnement s'il n'a aps t cr ( sous ie )
	if(!e){
		e = window.event;
	}
	//Dtection de l'lment sur lequel on a click
	monElement = (e.target)? e.target:e.srcElement;

	if(monElement) {
		if(monElement.id.indexOf("mobile_") == 0) {
			movable = true;
			myObjectClick = document.getElementById("popup_"+monElement.id.split("_")[1]);
		}
		else if(monElement.id.indexOf("curseur_") == 0) {
			glissable = true;
			myObjectClick = monElement;
		}
		if(myObjectClick){
			positionXAtClick = e.clientX;
			positionYAtClick = e.clientY;
			positionXMyobjectClick = parseInt(myObjectClick.offsetLeft);
			positionYMyobjectClick = parseInt(myObjectClick.offsetTop);
			return false;
		}
	}
}
function drag_v(e){
	//On initialise l'vnement s'il n'a pas t cr ( sous ie )
	if(!e){
		e = window.event;
	}

	//Si l'objet est dplaable et qu'il existe
	if(movable && myObjectClick){
		myObjectClick.style.position = "absolute";
		//On rcupre la position de la souris par rapport  l'objet
		myObjectClick.style.left = e.clientX + ( positionXMyobjectClick - positionXAtClick ) + "px";
		myObjectClick.style.top = e.clientY + ( positionYMyobjectClick - positionYAtClick ) + "px";
		return false;
	}
	if(glissable && myObjectClick){
		myObjectClick.style.position = "relative";
		//On rcupre la position de la souris par rapport  l'objet
		valeur = Math.max(0,Math.min(100,e.clientX + ( positionXMyobjectClick - positionXAtClick )));
		myObjectClick.style.left = valeur + "px";
		valeur_curseur(myObjectClick.id.split("_")[2], valeur);
		//myObjectClick.style.top = e.clientY + ( positionYMyobjectClick - positionYAtClick ) + "px";
	}
}
function drop_v(){
	myObjectClick = null;
	movable = false;
	glissable = false;
	positionXAtClick = null;
	positionYAtClick = null;
	positionXMyobjectClick = null;
	positionYMyobjectClick = null;
}

////////////////////////
//fonctions lmentaires
function aj_css_fptt(fichier) {
	newcss = document.createElement("link");
	newcss.rel = "stylesheet";
	newcss.type = "text/css";
	newcss.id = "fichier_style";
	newcss.href = fichier+"fptt.css";
	document.getElementsByTagName("head")[0].appendChild(newcss);
}
function illustr(source,titre,autre) {
	imag = document.createElement("img");
	imag.src = chemin+source;
	imag.title = titre;
	imag.alt = autre;
	return imag;
}
function bloc(ref) {
	nvdiv = document.createElement("div");
	nvdiv.id = ref;
	return nvdiv;
}
function enligne(ref) {
	nvspan = document.createElement("span");
	nvspan.id = ref;
	return nvspan;
}
function aligne() {
	nspan = document.createElement("span");
	nspan.className = "aligne";
	return nspan;
}
function espacer(noeud) {
	noeud.appendChild(document.createTextNode(" "));
}
function opt_val(ref,defaut) {
	if(isNaN(parseInt(document.getElementById("v2d_"+ref).value))) return defaut;
	return parseInt(document.getElementById("v2d_"+ref).value);
}
function ligne_titre() {
	nlleligne = document.createElement("tr");
	nlleligne.className = "mh_tdtitre";
	return nlleligne;
}
function trim(str) {
   return str.replace(/(^\s*)|(\s*$)/g,"");
}
function insert_texte(texte) {
	divtexte = document.createElement("div");
	divtexte.appendChild(document.createTextNode(texte) )
	divtexte.className = "texte_enligne";
	return divtexte;
}
/////////////////
//Gestion options
function lire_opt() {
	etik = ["h","v","i_ta","i_tp","i_tn","i_te","i_ti","i_m","i_mg","i_moqp","i_oc","i_och","i_oob","i_og","i_oe","i_op","i_o","i_ooqp","i_c","i_om","i_l","i_lt","i_lp","i_ls","i_ltm","i_lc","i_lm","spec_obj","spec_lieux","ouvre_dist","affich_fptt","opaque","i_ooa","i_ooa1","i_ooa2","i_ooc","i_ooe","i_oot","ico","opt_spe","i_oa","i_oca"];
	defaut = [10,5,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,25,true,true,true,true,true,true,12,false,true,true,false];
	nb_options = defaut.length;

	pack = "http://feldspath.free.fr/feldspatatrac/";
	for(i=0;i<nb_options;i++) {
		opt[etik[i]] = defaut[i];
	}
	if(MZ_getValue("FELDSPATATRAC")) {
		option_valeurs = MZ_getValue("FELDSPATATRAC").split("/");
		nb_options = Math.min(option_valeurs.length/2);
		if(nb_options > 20) {
			for(i=0; i<nb_options; i++) {
				if(opt[option_valeurs[2*i]] === undefined) continue;
				if (typeof opt[option_valeurs[2*i]] == "boolean") { opt[option_valeurs[2*i]] = (option_valeurs[2*i+1] == 1); }
				else {  opt[option_valeurs[2*i]] = parseInt(option_valeurs[2*i+1]);}
			}
		}
	}
	if(MZ_getValue("FELDSPATATRAC_CHEMIN")) {
		pack = MZ_getValue("FELDSPATATRAC_CHEMIN");
	}
	chemin = definir_chemin(pack);
	ico_ref = opt["ico"];
}
function sauver_opt() {
	liste_options = "";
	for(var i in opt) {
		liste_options += i+"/";
		if(typeof opt[i] == "boolean") { liste_options += ((opt[i])? 1:0) + "/"; }
		else { liste_options += opt[i] + "/"; }
	}
	MZ_setValue("FELDSPATATRAC",liste_options);
}

//////////////////////////////
//compatibilit multinavigateurs
if("function" != typeof MZ_getValue) {
	if("function" == typeof GM_getValue) {
		function MZ_getValue(nom) {
			return GM_getValue(nom);
		}
		function MZ_setValue(nom,valeur) {
			GM_setValue(nom,valeur);
		}
	}
	else if("function" == typeof PRO_getValue) {
		function MZ_getValue(nom) {
			return PRO_getValue(nom);
		}
		function MZ_setValue(nom,valeur) {
			PRO_setValue(nom,valeur);
		}
	}
	else {
		function MZ_getValue(nom) {
			var dc = document.cookie;
			var prefix = nom + "=";
			var begin = dc.indexOf("; " + prefix);
			if (begin == -1) {
				begin = dc.indexOf(prefix);
				if (begin != 0) return "";
			}
			else
				begin += 2;
			var end = document.cookie.indexOf(";", begin);
			if (end == -1)
				end = dc.length;
			return unescape(dc.substring(begin + prefix.length, end));
		}
		function MZ_setValue(nom,valeur) {
			var expdate = new Date ();
			expdate.setTime (expdate.getTime() + (24 * 60 * 60 * 1000 * 31));
			var curCookie = nom + "=" + escape(valeur) + "; expires="+expdate.toGMTString();
			document.cookie = curCookie;
		}
	}
}
function addEvent(obj, typ, fn, sens) {
	if (ie) {
		obj["e"+typ+fn] = fn; obj[typ+fn] = function() {
			obj["e"+typ+fn]( window.event );
		}
		obj.attachEvent("on"+typ, obj[typ+fn] );
	}
	else
		obj.addEventListener(typ, fn, sens);
}
function effaceEvent(obj,typ,fn,sens) {
	if (ie) {
		obj.detachEvent("on"+typ, obj[typ+fn]);
	}
	else {
		obj.removeEventListener(typ, fn, sens);
	}
}
function parNom(nom) {
	if(ie) {
		listeNom = new Array();
		parI = document.getElementsByTagName("img");
		for(var i in parI) {
			if (parI[i].name == nom) listeNom.push(parI[i]);
		}
		return listeNom;
	}
	else {
		return document.getElementsByName(nom);
	}
}

function get_opt(ref) {
	// return document.forms["opt_vue_spe"].elements[ref].value;
	return document.getElementById(ref).value;
}
function set_opt(ref,val) {
	// document.forms["opt_vue_spe"].elements[ref].value = val;
	document.getElementById(ref).value = val;
}

//////////////////////////////
//Intgration vue
function creer_ligne_fptt() {
	nvtr = ligne_titre();
	nvtr.id = "ligne_fptt";
	nvtd = document.createElement("td");
	nvtd.colSpan = "2";

	nvtd.appendChild(illustr("vue_pt.png","Vue 2D","Vue 2D"));
	nvtd.	appendChild(document.createTextNode(" Centre : X = "));
	nvtd.appendChild(aj_entree("v2d_x", posx));
	nvtd.	appendChild(document.createTextNode(" Y = "));
	nvtd.appendChild(aj_entree("v2d_y", posy));
	nvtd.	appendChild(document.createTextNode(" N = "));
	nvtd.appendChild(aj_entree("v2d_n", posn));
	nvtd.	appendChild(document.createTextNode(" Porte horizontale = "));
	nvtd.appendChild(aj_entree("v2d_h", opt["h"]));
	nvtd.	appendChild(document.createTextNode(" verticale = "));
	nvtd.appendChild(aj_entree("v2d_v", opt["v"]));
	nvtd.	appendChild(document.createTextNode("  "));

	entree = document.createElement("input");
	entree.type = "button";
	entree.className = "mh_form_submit";
	entree.value = "Afficher";
	addEvent(entree, "click", afficher_vue, true);
	nvtd.className = "mh_tdtitre";
	nvtd.appendChild(entree);
	nvtd.appendChild(document.createTextNode(" "));

	sp = aj_opt_fptt("ouvre_dist","Distances cliquables");
	addEvent(sp.firstChild, "click", function() { click_dist(this.checked) }, true);
	if(opt["ouvre_dist"]) click_dist(true)
	nvtd.appendChild(sp);
	nvtr.appendChild(nvtd);
	tableau_tete[0].appendChild(document.createElement("tfoot"))
	tableau_tete[0].lastChild.appendChild(nvtr);
}
function opt_mz() {
	sp = aj_opt_fptt("affich_fptt","Ligne Feldspatatrac");
	addEvent(sp.firstChild,"click", function() { alterne_ligne(this.checked) },true);
	tableau_tete[0].childNodes[1].childNodes[0].childNodes[1].appendChild(sp);
}
function alterne_ligne(coche) {
	opt["affich_fptt"] = coche;
	sauver_opt();
	document.getElementById("ligne_fptt").parentNode.style.display = (coche)? "none":""
}
function click_dist(coche) {
	opt["ouvre_dist"] = coche;
	sauver_opt();
	if(coche) {
		prepare_click(1, "m");
		prepare_click(2, "t");
		prepare_click(3, "o");
		prepare_click(4, "c");
		prepare_click(5, "l");
	}
	else {
		for (var j=1; j<6; j++) { efface_click(j); }
	}
}
function prepare_click(num,etik) {
	var tableau = new Array();
	if(tableau_tete[num].getElementsByTagName("thead").length > 0) {
		tableau = tableau_tete[num].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
		debut = 1;
	}
	else {
		tableau = tableau_tete[num].getElementsByTagName("tbody")[0].getElementsByTagName("tr");
		debut = 2;
	}
	nb = tableau.length;
	if(nb > debut) {
		xx = tableau[debut].childNodes.length-3; yy = tableau[debut].childNodes.length-2; nn = tableau[debut].childNodes.length-1;
		for (var i = debut; i < nb; i++) {
			if(tableau[i].childNodes.length <3) continue;
			tableau[i].firstChild.id = etik+i+"_"+tableau[i].childNodes[xx].firstChild.nodeValue+"_"+tableau[i].childNodes[yy].firstChild.nodeValue+"_"+tableau[i].childNodes[nn].firstChild.nodeValue;
			addEvent(tableau[i].firstChild,"click", function(event) { excentrer(this.id,event) }, true);
			tableau[i].firstChild.style.cursor = "pointer";
			tableau[i].firstChild.title = "Feldspatatrac!";
		}
	}
}
function efface_click(num) {
	var tableau = new Array();
	if(tableau_tete[num].getElementsByTagName("thead").length > 0) {
		tableau = tableau_tete[num].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
		debut = 1;
	}
	else {
		tableau = tableau_tete[num].getElementsByTagName("tbody")[0].getElementsByTagName("tr");
		debut = 2;
	}
	nb = tableau.length;
	for (var i = debut; i < nb; i++) {
		if(tableau[i].childNodes.length <3) continue;
		// effaceEvent(tableau[i].firstChild,"click", function(event) { excentrer(this.id,event) }, true);
		tableau[i].firstChild.style.cursor = "";
		tableau[i].firstChild.title = "";
	}
}
function creer_entete() {
	for (var j=1; j<6; j++) {
		if(tableau_tete[j].getElementsByTagName("thead").length == 0) {
			var newThead = document.createElement("thead");
			newThead.appendChild(tableau_tete[j].getElementsByTagName("tbody")[0].getElementsByTagName("tr")[0]);
			tableau_tete[j].insertBefore(newThead,tableau_tete[j].childNodes[0]);
		}
	}
	x_m = tableau_tete[1].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
	x_t = tableau_tete[2].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
	x_o = tableau_tete[3].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
	x_c = tableau_tete[4].getElementsByTagName("tbody")[1].getElementsByTagName("tr");
	x_l = tableau_tete[5].getElementsByTagName("tbody")[1].getElementsByTagName("tr")
	nb_m = x_m.length;
	nb_t = x_t.length;
	nb_o = x_o.length;
	nb_c = x_c.length;
	nb_l = x_l.length;
	entetes_crees = true;
}

/////////////////////
//Lancement du script
if(window.self.location.toString().indexOf("/mountyhall/MH_Play/Play_vue.php") !=-1) {//i.e. page vue
// if(true) {
	//Initialisation des paramtres
	//paramtres de l'affichage : dcalage de la map  gauche et en haut
	var decal_h=35, decal_v=25, larg=null, xold = null, yold = null, cold = [null, null, null, null, null];
	var descase = new Array(), vu = new Array(), coord = new Array(), opt = new Array(), compte = new Array(), tableau_tete = new Array();
	var vue_cree = false, vue_reduite = false, fixe = false, opt_crees = false, ini_style = true, entetes_crees = false;
	var bulle_vue = null, ancre = null, opt_vue = null, opt_vue_spe = null, popup_vue = null;
	var taille = 0, dh = 0, dv = 0, dx = 0, dy = 0;
	var chemin = "", pack = "";
	var ie = (window.attachEvent)? true:false;
	var chrono = 0, ico_refico_ref = 0;
	var classes = new Array();

	var movable = false, glissable = false;
	var myObjectClick = null, positionXAtClick = null, positionYAtClick = null, positionXMyobjectClick = null, positionYMyobjectClick = null;
	var corps_page = document.getElementsByTagName("body")[0];

	var x1, y1, n1, v1, h1, xmin, xmax, ymin, ymax, nmin, nmax;
	var x_m = new Array(), x_t = new Array(), x_o = new Array(), x_c = new Array(), x_l = new Array();
	var nb_m=0, nb_t=0, nb_o=0, nb_c=0, nb_l=0;

	j = 0;
	tableaux = document.getElementsByTagName("table");
	for (var i=0;i<tableaux.length;i++) {
		if (tableaux[i].className == "mh_tdborder") {
			tableau_tete[j]=tableaux[i];
			j++;
		}
	}

	var liste = document.getElementsByTagName("li");
	var position = liste[0].innerHTML.match(/(-?\d+)/g), portee = liste[2].innerHTML.match(/(\d+)/g);
	var posx = parseInt(position[0]), posy = parseInt(position[1]), posn = parseInt(position[2]), vueh = parseInt(portee[0]), vuev = parseInt(portee[1]);

	lire_opt();
	creer_ligne_fptt();
	//Instructions css complmentaires
	aj_css_fptt(chemin);
	ini_css();

	if(tableau_tete[0].childNodes[1].getElementsByTagName("tr").length > 2) {
		opt_mz();
		if(opt["affich_fptt"]) alterne_ligne(true);
	}
}
